﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
using Windows.UI.Core;
using Windows.UI.Popups;
using Windows.ApplicationModel.Resources;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x409

namespace LabelPrinterSample
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public static MainPage Current;
        public string printerId = "PB32_Fingerprint";
        public string printerMacAddress = "00:06:66:08:68:EE";

        public MainPage()
        {
            this.InitializeComponent();

            // This is a static internal property that allows downstream pages to get a handle to the MainPage instance
            // in order to call methods that are in this class.
            Current = this;
        }

        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            base.OnNavigatedTo(e);
        }
        private void HamburgerButton_Click(object sender, RoutedEventArgs e)
        {
            MySplitView.IsPaneOpen = !MySplitView.IsPaneOpen;
        }

        private void CatagrayList_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (PrinterSettings.IsSelected)
            {
                PrinterSettingStackPanel.Visibility = Visibility.Visible;
                myFrame.Visibility = Visibility.Collapsed;
            }
            else if (ItemLabel.IsSelected)
            {
                PrinterSettingStackPanel.Visibility = Visibility.Collapsed;
                myFrame.Visibility = Visibility.Visible;
                myFrame.Navigate(typeof(PrintItemLabelPage));
            }
            else if (URLLable.IsSelected)
            {
                PrinterSettingStackPanel.Visibility = Visibility.Collapsed;
                myFrame.Visibility = Visibility.Visible;
                myFrame.Navigate(typeof(PrintURLLabelPage));
            }

            MySplitView.IsPaneOpen = false;
        }

        private void PrinterIDComoBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            var selectedItem = e.AddedItems[0] as ComboBoxItem;
            printerId = selectedItem.Content as string;
        }

        private async void PrinterMACAddressTextBox_LostFocus(object sender, RoutedEventArgs e)
        {
            if (string.IsNullOrWhiteSpace(PrinterMACAddressTextBox.Text))
            {
                await Dispatcher.RunAsync(CoreDispatcherPriority.Normal, () =>
                {
                    ShowErrorMessage("Printer address is required");
                    printerMacAddress = string.Empty;
                });
            }
            else
            {
                printerMacAddress = PrinterMACAddressTextBox.Text.Trim();
            }
        }
        public async void ShowErrorMessage(string errorString)
        {
            MessageDialog messageDialog = new MessageDialog(errorString, "Error");
            await messageDialog.ShowAsync();
        }
    }
}
